import java.io.*;

// run DataShopToGamingDetectorpt1C (or E?) first

public class DataShopToGamingDetectorpt2A{

    //String infile = "C:\\from-scooter-dec-2008\\RawData\\RonExampleTutors\\RonExampleTutorsA-MLA-reskill-B.txt";
    //String infile = "C:\\from-scooter-dec-2008\\RawData\\HamptonGeoFall2005\\HamptonGeo0506B-MLA-B.txt";
    public static String infile = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C-MLA-A.txt";

    //String outfile_nothi = "C:\\changed-dec-2008-jan-2009\\RawData\\RonExampleTutors\\RonExampleTutorsB-GDA.txt";
    //String outfile_nothi = "HamptonGeo0506B-GDA-Balt.txt";
    public static String outfile_nothi = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C-GDA-full-C.txt";

    String pknowfile = "C:\\Study-Analyses\\BetterGuessSlip\\Java-Based\\bounded-algebra-B-GDformat.txt";

    StreamTokenizer st_;
    FileWriter fw_;

    java.util.Hashtable totalticks = new java.util.Hashtable();
    java.util.Hashtable numincidents = new java.util.Hashtable();
    java.util.Hashtable deviance = new java.util.Hashtable();
    java.util.Hashtable pknowfound = new java.util.Hashtable();
    
    public boolean retrack_all = true;

    public boolean mtm_v1 = false; // false = v6 or v13
    public boolean mtm_v2 = false;
    public boolean mtm_v3 = false;

    public boolean v13 = true; // false = v6... (leave as true for mtms)

    java.util.Hashtable L0_ = new java.util.Hashtable();
    java.util.Hashtable T_ = new java.util.Hashtable();
    java.util.Hashtable S_ = new java.util.Hashtable();
    java.util.Hashtable G_ = new java.util.Hashtable();

    boolean SD_by_cell = true; // false = SD by prod

    public boolean first_only = false;

    public void mldatadistller(){}

    public StreamTokenizer create_tokenizer(){		      
	
	try{
	    return new StreamTokenizer(new FileReader(infile));
	}
	catch (FileNotFoundException fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }
    
    public FileWriter out_tokenizer(){
	try{
	    return new FileWriter(outfile_nothi);
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }

    public double get_time_SD(String relevant, double curtime){
	// relevant can be either a cell or prod
	//	System.out.print(relevant + ";");
	double cell_mean = ((Double)totalticks.get(relevant)).doubleValue() / ((Long)numincidents.get(relevant)).doubleValue();
	
	//System.out.println(((Long)numincidents.get(relevant)).doubleValue());
	//System.out.println(((Double)deviance.get(relevant)).doubleValue());

	double cell_sd = Math.sqrt(((Double)deviance.get(relevant)).doubleValue() / ((Long)numincidents.get(relevant)).doubleValue());

	return (curtime - cell_mean)/cell_sd;
    
    }

    public void print_out_hashtables(){
	System.out.println(totalticks.toString());
	System.out.println(deviance.toString());
	System.out.println(numincidents.toString());
    }

    public void learn_sdev_mean(){
	boolean quitnow = false;
	String relevant = "";
	String cellhere = "";
	String prod = ""; String lesson="";
	int count=0;

	int tt;
	// first pass to learn mean time
	try{
	st_ = create_tokenizer();
	while (!quitnow){
	    tt = st_.nextToken();
	    if (tt==StreamTokenizer.TT_EOF)
		quitnow=true;
	    else{
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    lesson = st_.sval;
	    st_.nextToken();
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    st_.nextToken();
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    st_.nextToken();
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    cellhere = st_.sval;
	    st_.nextToken();
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    st_.nextToken();
	    while (st_.sval == null){
		st_.nextToken();
	    }
	    prod = st_.sval;
	    tt = st_.nextToken();
	    while (tt != StreamTokenizer.TT_NUMBER){
		tt = st_.nextToken();
	    }
	    if (st_.nval != -1.0){

		pknowfound.put(prod, new Integer(7));
	    }
	    tt = st_.nextToken();
	    while (tt != StreamTokenizer.TT_NUMBER){
		tt = st_.nextToken();
	    }
	    if (SD_by_cell)
		relevant = lesson+cellhere;
	    else
		relevant = lesson+prod;
	    
	    // System.out.println(relevant);
	    if (totalticks.get(relevant)!=null){
		totalticks.put(relevant, new Double(st_.nval + ((Double)totalticks.get(relevant)).doubleValue()));}
	    else
		totalticks.put(relevant, new Double(st_.nval));
	    if (numincidents.get(relevant) != null)
		numincidents.put(relevant, new Long(1 + ((Long)numincidents.get(relevant)).longValue()));
	    else
		numincidents.put(relevant, new Long(1));
	    // System.out.println(numincidents_);

	    tt = st_.nextToken();
	    while (tt != StreamTokenizer.TT_NUMBER){
		tt = st_.nextToken();
	    } 
	    tt = st_.nextToken();
	    while (tt != StreamTokenizer.TT_NUMBER){
		tt = st_.nextToken();
	    } 
	    tt = st_.nextToken();
	    while (tt != StreamTokenizer.TT_NUMBER){
		tt = st_.nextToken();
	    }
	    }
	}
	}catch (Exception e){ e.printStackTrace(); quitnow=true;}
	//st_.close();
	//mean_ = totalticks_ / new Double(numincidents_).doubleValue();

	//totalticks_ = 0.0;
	// second pass to learn sdev on time
	try{
	st_ = create_tokenizer();
	quitnow = false;
	while (!quitnow){
	    tt = st_.nextToken();
	    count++;
	    if (tt==StreamTokenizer.TT_EOF)
		quitnow=true;
	    else{
		while ((st_.sval == null)&&(quitnow==false)){
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
		} 
		lesson=st_.sval;
		tt=st_.nextToken();
		while ((st_.sval == null)&&(quitnow==false)){
		    
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
		} 

	    st_.nextToken();
	    while ((st_.sval == null)&&(quitnow==false)){
	        
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    st_.nextToken();
	    while ((st_.sval == null)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    cellhere = st_.sval;
	    st_.nextToken();
	    while ((st_.sval == null)&&(quitnow==false)){
	       
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    tt = st_.nextToken(); 
	    prod = st_.sval;
	    while ((tt != StreamTokenizer.TT_NUMBER)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    tt = st_.nextToken();
	    while ((tt != StreamTokenizer.TT_NUMBER)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    tt = st_.nextToken();
	    while ((tt != StreamTokenizer.TT_NUMBER)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    tt = st_.nextToken();
	    while ((tt != StreamTokenizer.TT_NUMBER)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }
	    tt = st_.nextToken();
	    while ((tt != StreamTokenizer.TT_NUMBER)&&(quitnow==false)){
		
		    tt=st_.nextToken();
		    if (tt==StreamTokenizer.TT_EOF)
			quitnow=true;
	    }

	    //System.out.println(count);
	    //System.out.println(cellhere); 
	    if (SD_by_cell)
		relevant = lesson+cellhere;
	    else
		relevant = lesson+prod;
	    //System.out.println(relevant);
	    //System.out.println(";;;;");
	    double mean = ((Double)totalticks.get(relevant)).doubleValue() / ((Long)numincidents.get(relevant)).doubleValue();	  
	    if (deviance.get(relevant)!=null)
		deviance.put(relevant,new Double(((mean - st_.nval)*(mean - st_.nval)) + ((Double)deviance.get(relevant)).doubleValue()));
	    else
		deviance.put(relevant,new Double(((mean - st_.nval)*(mean - st_.nval))));		   
	    }
	}
	}catch (Exception e){ e.printStackTrace(); quitnow=true;}
	//st_.close();
        //sdev_ = Math.sqrt(totalticks_ / new Double(numincidents_).doubleValue());
    
    }

    public void distill(){
	
	st_ = create_tokenizer();
	fw_ = out_tokenizer();
	boolean quitnow = false;

	quitnow = false;
	long num = 0; String lesson = ""; String namea = ""; String nameb = ""; String assess = "";
	String cell = ""; String celltype = ""; String prod = "";
	double pknow = 0; double time = 0; double timeSDnormed = 0;
	double prevpknow = -1; double pknowretro = -1;
	double timelast3SDnormed = 0; double timelast5SDnormed = 0;
	long notright = 0; int tt = 0; int numprobs = 0; boolean MMS = false;
	double timeago = 0; double time2ago = 0; double time3ago = 0;
	double time4ago = 0; double time5ago = 0; String punchange = "0";
	int time_since_nameswitch = 0; String roight = "0"; String boug = "0"; 	
	String help = "0"; double numsteps = 0; double helpintermedtime = 0;
	double lpisabs = 0; double lpisinvert = 0;
	double lpisinvertsqrt = 0; double newprob = 0;

	String prevcell1 = ""; String prevcell2 = "";
	String prevcell3 = ""; String prevcell4 = "";
	String prevcell5 = ""; int prev3count = 0; int prev5count = 0;

	int help8 = 0; int help7 = 0; int help6 = 0; int help5 = 0;
	int help4 = 0; int help3 = 0; int help2 = 0; int help1 = 0;
	int recent8help = 0;

	int wrong5 = 0; int wrong4 = 0; int wrong3 = 0; int wrong2 = 0; 
	int wrong1 = 0; int recent5wrong = 0;

	String asymptoteA = "0"; String asymptoteB = "0";

	String manywrong = "0";

	String choice = "0"; String string = "0"; 
	String number = "0"; String point = "0"; String blank = "0";

	String curstu = ""; java.util.Hashtable wrongpercell = null;
	java.util.Hashtable prodhelpsofar = null;
	java.util.Hashtable prodrightsofar = null;
	java.util.Hashtable prodwrongbugsofar = null;

	java.util.Hashtable timeperaction = null;
	java.util.Hashtable numofaction = null;

	java.util.Hashtable touched = null;

	ktcode2 ktc_ = new ktcode2();

	while (!quitnow){
	    lesson = "";
	    namea = ""; nameb = ""; assess = "";
	    cell = ""; celltype = ""; prod = "";
	    pknow = 0; time = 0; timeSDnormed = 0;
	    helpintermedtime = 0; numsteps = 0;
	    roight = "0"; boug = "0"; help = "0";
	    punchange = "0"; pknowretro = 0;
	    choice = "0"; string = "0"; number = "0"; point = "0"; blank = "0";

	    timelast3SDnormed = 0; timelast5SDnormed = 0;
	    notright = 0; MMS = false;
	    
	    prev3count = 0;prev5count = 0; recent8help = 0; recent5wrong = 0;
	    manywrong = "0";
	  
	    asymptoteA = "0"; asymptoteB = "0";

	    newprob = 0;

	    try{
		// input-ing one record


		tt = st_.nextToken();
		if (tt == StreamTokenizer.TT_EOF)
		    quitnow=true;
		else{
		num+=1; 

		while (st_.sval == null){
		    tt = st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		lesson = st_.sval; 		
		
		st_.nextToken();
		while (st_.sval == null){
		    tt = st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		namea = st_.sval; 

		if (!namea.equals(curstu)){
		    //System.out.println("switching to student "+ namea );
		    curstu = namea;
		    prevpknow = -1; 
		    prevcell1 = ""; prevcell2 = ""; prevcell3 = "";
		    prevcell4 = ""; prevcell5 = "";
		    
		    help8=0; help7=0; help6=0; help5=0; help4=0;
		    help3=0; help2=0; help1=0;

		    wrong5=0; wrong4=0;wrong3=0;wrong2=0;wrong1=0;

		    wrongpercell = new java.util.Hashtable();
		    prodhelpsofar = new java.util.Hashtable();
		    prodrightsofar =new java.util.Hashtable(); 
		    prodwrongbugsofar =  new java.util.Hashtable();
		    timeperaction =  new java.util.Hashtable();
		    numofaction =  new java.util.Hashtable();

		    touched = new java.util.Hashtable();
		    ktc_ = new ktcode2();
		    
		    numprobs = 0;
		    time_since_nameswitch = 0; 
		}

		st_.nextToken();
		while (st_.sval == null){
		    tt= st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		assess = st_.sval; 		

		st_.nextToken();
		while (st_.sval == null){
		    tt = st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		cell = st_.sval; 

		// count recent same cells
		if (prevcell1.equals(cell)){
		    prev3count++;
		    prev5count++;
		}
		if (prevcell2.equals(cell)){
		    prev3count++;
		    prev5count++;
		}
		if (prevcell3.equals(cell)){
		    prev3count++;
		    prev5count++;
		}
		if (prevcell4.equals(cell)){
		    prev5count++;
		}
		if (prevcell5.equals(cell)){
		    prev5count++;
		}
		
		if (cell.equals("NIL")){
		    prev3count = 0;
		    prev5count = 0;
		}

		prevcell5 = prevcell4; prevcell4 = prevcell3; 
		prevcell3 = prevcell2; prevcell2 = prevcell1;
		prevcell1 = cell;

		// count recent helps
		
		recent8help = help8 + help7 + help6 + help5 + help4 + help3 + help2 + help1;
		help8 = help7; help7 = help6; help6 = help5; help5= help4;
		help4 = help3; help3 = help2; help2 = help1;
		help1= 0; // will become 1 if it is a help, later on.

		// count recent wrong
		recent5wrong = wrong5 + wrong4 + wrong3 + wrong2 + wrong1;
		wrong5 = wrong4; wrong4 = wrong3; wrong3 = wrong2; 
		wrong2 = wrong1; wrong1 = 0; // will become 1 later on
		
		if ((prev5count>=3)&&(recent5wrong>=3))
		    manywrong = "1";		

		st_.nextToken();
		while (st_.sval == null){
		    tt= st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		celltype = st_.sval; 

		if (celltype.equals("CHOICE"))
		    choice = "1";
		if (celltype.equals("STRING"))
		    string = "1";
		if (celltype.equals("NUMBER"))
		    number = "1";
		if (celltype.equals("POINT"))
		    point = "1";
		if (celltype.equals("BLANK"))
		    blank = "1";
		
		st_.nextToken();
		while (st_.sval == null){
		    tt = st_.nextToken();
		    if (tt == StreamTokenizer.TT_EOF)
			throw new Exception("Reached EOF.");
		}
		prod = st_.sval; 		

		tt = st_.nextToken();
		while (tt != StreamTokenizer.TT_NUMBER)
		    tt = st_.nextToken();
		pknow = st_.nval; 
		pknowretro = pknow;
		
	        tt = st_.nextToken();
		while (tt != StreamTokenizer.TT_NUMBER)
		    tt = st_.nextToken();
		time = st_.nval; 			      

		if (tt == StreamTokenizer.TT_EOF)
		    quitnow=true;

		String murf="";
		if (SD_by_cell)		  
		    murf = lesson + cell;
		else
		    murf = lesson + prod;
		
		timeSDnormed = get_time_SD(murf,time);

		if (time_since_nameswitch > 2){
		    timelast3SDnormed = timeago+time2ago+time3ago;
		}
		if (time_since_nameswitch > 4){
		    timelast5SDnormed = timeago+time2ago+time3ago+time4ago+time5ago;
		}

		time_since_nameswitch++;
	
		tt = st_.nextToken();
		while (tt != StreamTokenizer.TT_NUMBER)
		    tt = st_.nextToken();
		newprob = st_.nval; 

		if (newprob == 1.0){
		    touched = new java.util.Hashtable();
		    //System.out.println("np");
		}

		tt = st_.nextToken();
		while (tt != StreamTokenizer.TT_NUMBER)
		    tt = st_.nextToken();
		helpintermedtime = st_.nval; 	

		tt = st_.nextToken();
		while (tt != StreamTokenizer.TT_NUMBER)
		    tt = st_.nextToken();
		numsteps = st_.nval; 			      

		if (numsteps <= 0){
		    lpisabs = 0;
		    lpisinvert = 0;
		    lpisinvertsqrt = 0;
		}else{
		lpisabs = helpintermedtime / numsteps;
		lpisinvert = 1/lpisabs;
		lpisinvertsqrt = 1/Math.sqrt(lpisabs);}

		if (tt == StreamTokenizer.TT_EOF)
		    quitnow=true;

		if (assess.equals("RIGHT")){
		    notright=0;
		    roight="1";
		}
		else{
		    notright=1;
		    roight = "0";
		}
		if (assess.equals("BUG"))
		    boug = "1";
		if (assess.equals("HELP")){
		    help="1";
		    help1 = 1;
		}
		if ((assess.equals("WRONG"))||(assess.equals("HELP"))||(assess.equals("BUG")))
		    wrong1 = 1;
		
		int howmanywrong = 0;
		Integer num_wrong = (Integer)wrongpercell.get(cell);
		if (notright == 1){
		    if (num_wrong == null)
			howmanywrong = 1;
		    else
			howmanywrong = num_wrong.intValue() + 1;
		    wrongpercell.put(cell,new Integer(howmanywrong));
		}
		else
		    if (num_wrong != null)
			howmanywrong = num_wrong.intValue();

		int prodhelp = 0;
		Integer prodhelpI = (Integer)prodhelpsofar.get(prod);
		if (assess.equals("HELP")){
		    if (prodhelpI == null)
			prodhelp = 1;
		    else
			prodhelp = prodhelpI.intValue() + 1;
		    prodhelpsofar.put(prod,new Integer(prodhelp));
		}
		    
		int prodright = 0;
		Integer prodrightI = (Integer)prodrightsofar.get(prod);
		if (assess.equals("RIGHT")){
		    if (prodrightI == null)
			prodright = 1;
		    else
			prodright = prodrightI.intValue() + 1;
		    prodrightsofar.put(prod,new Integer(prodright));
		}
		    
		int prodwrongbug = 0;
		Integer prodwbI = (Integer)prodwrongbugsofar.get(prod);
		if ((assess.equals("WRONG"))||(assess.equals("BUG"))){
		    if (prodwbI == null)
			prodwrongbug = 1;
		    else
			prodwrongbug = prodwbI.intValue() + 1;
		    prodwrongbugsofar.put(prod,new Integer(prodwrongbug));
		}
		 
		double total = 0;
		Double totalT = (Double)timeperaction.get(prod);
		if (totalT == null)
		    total = time;
		else
		    total = totalT.doubleValue() + time;
		timeperaction.put(prod,new Double(total));		

		int actions = 0;
		Integer actionsT = (Integer)numofaction.get(prod);
		if (actionsT == null)
		    actions = 1;
		else
		    actions = actionsT.intValue() + 1;
		numofaction.put(prod,new Integer(actions));
		
		double helppct = 0; double wrongpct = 0;
		if (numprobs>0){
		    helppct = new Double(prodhelp).doubleValue() / (new Double(numprobs).doubleValue());
		    wrongpct = new Double(prodwrongbug).doubleValue() / (new Double(numprobs).doubleValue());
		}
		else{
		    helppct = new Double(prodhelp).doubleValue() ;
		    wrongpct = new Double(prodwrongbug).doubleValue();
		}
		double timeperact = new Double(total).doubleValue() / (new Double(actions).doubleValue());

		time5ago = time4ago; time4ago=time3ago; time3ago=time2ago;
		time2ago = timeago; timeago = timeSDnormed;
			
		if (retrack_all){
		    //System.out.println(cell);
		    if (touched.get(cell)==null){
			//	System.out.println("nsb");
			punchange = "0";
			if (ktc_.getCurrentSkill(prod)== -1){   	    
			    ktc_.initializeSkill(prod, param_estimated(prod,0),param_estimated(prod,1),param_estimated(prod,2),param_estimated(prod,3)); 
			}
			ktc_.updateSkill(prod, (roight.equals("1")));
			if (!cell.equals("NIL"))
			    touched.put(cell,prod);
		    }
		    else
			punchange = "1";
		    if (param_estimated(prod,0)==-1){
			pknow = -2;
		    }
		    else
			pknow = ktc_.getCurrentSkill(prod);

		    if (punchange.equals("1"))
			pknowretro = -1;
		    else
			pknowretro = pknow;
		}
		else
		    //if ((pknowfound.get(prod)== null)){ 
			// tracking an untracked skill
			if (touched.get(cell)==null){	
			    punchange="0";
			    if (ktc_.getCurrentSkill(prod)== -1){
				ktc_.initializeSkill(prod, 0.42, 0.14, 0.26, 0.08);	       // average skill values for algebra
			    }
			    ktc_.updateSkill(prod, (roight.equals("1")));
			    if ((!cell.equals("NIL"))&&(!roight.equals("1")))
				touched.put(cell,prod);
			}
			else
			    punchange = "1";	   
			pknow = ktc_.getCurrentSkill(prod);	 
			//}
		if (pknow == -1){
		    //punchange = "1";	
		    pknow = prevpknow;
		}
		else{
		    //punchange = "0";
		    prevpknow = pknow;
		}		       
		
		if (cell.equals("AREAQUESTION1INPUTCELLVALUE")){
		    // System.out.print(num);
		    //System.out.print("\t");
		    //System.out.println(punchange);
		}

		if (v13){
		    if (param_estimated(prod,1)>0.9)
			asymptoteA="1";	    
		    if (param_estimated(prod,1)<0.01)
			asymptoteB="1";
		}

		//System.out.println(pknow);
		//System.out.println(prod);
		
		// output-ing the record

		//	if ((pknowfound.get(prod)!= null) && (!namea.equals("KHPAMBC")))		    // eliminate no-pknows-found skills... just to try...

		if (mtm_v3){
		    fw_.write(lesson+"\t");	
		    fw_.write(namea+"\t");
		    fw_.write(prod+"\t");
		    fw_.write(cell+"\t");
		    fw_.write(roight+"\t");//0
		    fw_.write(boug+"\t");//1
		    fw_.write(help+"\t");//2
		    fw_.write(choice+"\t");//3
		    fw_.write(string+"\t");//4
		    fw_.write(number+"\t");//5
		    fw_.write(point+"\t");//6
		    fw_.write(new Double(pknowretro).toString()+"\t");//7
		    fw_.write(new Double(pknow).toString()+"\t");//8
		    fw_.write(punchange+"\t");//9
		    fw_.write(new Double(time).toString()+"\t");//10
		    fw_.write(new Double(timeSDnormed).toString()+"\t");//11
		    fw_.write(new Double(timelast3SDnormed).toString()+"\t");//12
		    fw_.write(new Double(timelast5SDnormed).toString()+"\t");//13
		    fw_.write(new Long(notright).toString()+"\t");//14 
		    fw_.write(new Integer(howmanywrong).toString()+"\t");//15
		    fw_.write(new Double(helppct).toString()+"\t");//16
		    fw_.write(new Double(timeperact).toString()+"\t");//17... subbed for 1/pknow in geoFomit
		    fw_.write(new Integer(prev3count).toString()+"\t");//18
		    fw_.write(new Integer(prev5count).toString()+"\t");//19
		    fw_.write(new Integer(recent8help).toString()+"\t");//20
		    fw_.write(new Integer(recent5wrong).toString()+"\t");//21
		    fw_.write(asymptoteA+"\t");//22
		    fw_.write(asymptoteB+"\t");//23
		    fw_.write(new Double(numsteps).toString()+"\t");//24
		    fw_.write(new Double(lpisinvert).toString()+"\t");//25
		    fw_.write(new Double(lpisinvertsqrt).toString()+"\t");//26
		}else
		    if (mtm_v2){			
			fw_.write(namea+"\t");
			fw_.write(prod+"\t");
			fw_.write(cell+"\t");
			fw_.write(roight+"\t");//0
			fw_.write(boug+"\t");//1
			fw_.write(help+"\t");//2
			fw_.write(choice+"\t");//3
			fw_.write(string+"\t");//4
			fw_.write(number+"\t");//5
			fw_.write(point+"\t");//6
			fw_.write(new Double(pknowretro).toString()+"\t");//7
			fw_.write(new Double(pknow).toString()+"\t");//8
			fw_.write(punchange+"\t");//9
			fw_.write(new Double(time).toString()+"\t");//10
			fw_.write(new Double(timeSDnormed).toString()+"\t");//11
			fw_.write(new Double(timelast3SDnormed).toString()+"\t");//12
			fw_.write(new Double(timelast5SDnormed).toString()+"\t");//13
			fw_.write(new Long(notright).toString()+"\t");//14 
			fw_.write(new Integer(howmanywrong).toString()+"\t");//15
			fw_.write(new Double(helppct).toString()+"\t");//16
			fw_.write(new Double(timeperact).toString()+"\t");//17... subbed for 1/pknow in geoFomit
			fw_.write(new Integer(prev3count).toString()+"\t");//18
			fw_.write(new Integer(prev5count).toString()+"\t");//19
			fw_.write(new Integer(recent8help).toString()+"\t");//20
			fw_.write(new Integer(recent5wrong).toString()+"\t");//21
			fw_.write(asymptoteA+"\t");//22
			fw_.write(asymptoteB+"\t");//23
		    }else
		    if (mtm_v1){
			fw_.write(namea+"\t");
			fw_.write(prod+"\t");
			fw_.write(cell+"\t");
			fw_.write(roight+"\t");//0
			fw_.write(boug+"\t");//1
			fw_.write(help+"\t");//2
			fw_.write(choice+"\t");//3
			fw_.write(string+"\t");//4
			fw_.write(number+"\t");//5
			fw_.write(point+"\t");//6
			fw_.write(new Double(pknowretro).toString()+"\t");//7
			fw_.write(new Double(pknow).toString()+"\t");//8
			fw_.write(punchange+"\t");//9
			fw_.write(new Double(time).toString()+"\t");//10
			fw_.write(new Double(timeSDnormed).toString()+"\t");//11
			fw_.write(new Double(timelast3SDnormed).toString()+"\t");//12
			fw_.write(new Double(timelast5SDnormed).toString()+"\t");//13
			fw_.write(new Long(notright).toString()+"\t");//14 
			fw_.write(new Double(timeperact).toString()+"\t");//15... subbed for 1/pknow in geoFomit
			fw_.write(new Integer(prev3count).toString()+"\t");//16
			fw_.write(new Integer(prev5count).toString()+"\t");//17
			fw_.write(new Integer(recent8help).toString()+"\t");//18
			fw_.write(new Integer(recent5wrong).toString()+"\t");//19
			fw_.write(asymptoteA+"\t");//20
			fw_.write(asymptoteB+"\t");//21
		    }
		    else{ //v6 or v13
			if ((!first_only)||(punchange.equals("0"))){
			   

			    //fw_.write(num+"\t");
		    fw_.write(lesson+"\t");
		    fw_.write(namea+"\t");
		    fw_.write(prod+"\t");
		    fw_.write(cell+"\t");
		    fw_.write(roight+"\t");//0
		    fw_.write(boug+"\t");//1
		    fw_.write(help+"\t");//2
		    fw_.write(choice+"\t");//3
		    fw_.write(string+"\t");//4
		    fw_.write(number+"\t");//5
		    fw_.write(point+"\t");//6
		    // fw_.write(blank+"\t");

		    fw_.write(new Double(pknowretro).toString()+"\t");//7
		    fw_.write(new Double(pknow).toString()+"\t");//8

		    fw_.write(punchange+"\t");//9
		    fw_.write(new Double(time).toString()+"\t");//10
		    fw_.write(new Double(timeSDnormed).toString()+"\t");//11
		    fw_.write(new Double(timelast3SDnormed).toString()+"\t");//12
		    fw_.write(new Double(timelast5SDnormed).toString()+"\t");//13
		    fw_.write(new Long(notright).toString()+"\t");//14
		    fw_.write(new Integer(howmanywrong).toString()+"\t");//15
		    fw_.write(new Double(helppct).toString()+"\t");//16
		    fw_.write(new Double(wrongpct).toString()+"\t");//17
		    fw_.write(new Double(timeperact).toString()+"\t");//18... subbed for 1/pknow in geoFomit
		    fw_.write(new Integer(prev3count).toString()+"\t");//19
		    fw_.write(new Integer(prev5count).toString()+"\t");//20
		    fw_.write(new Integer(recent8help).toString()+"\t");//21
		    fw_.write(new Integer(recent5wrong).toString()+"\t");//2
		    if (v13){
			fw_.write(manywrong+"\t");//23
			fw_.write(asymptoteA+"\t");//24
			fw_.write(asymptoteB+"\t");//25
		    }
		    fw_.write("EOL");


		    fw_.write("\n");
		    fw_.flush();
			    
			}
		    }
		
		}
	    }catch(Exception e){e.printStackTrace(); quitnow=true;}    
		}

	try{
	    fw_.flush();
	    fw_.close();
	}
	catch (Exception e){
	    e.printStackTrace();
	}
	System.out.println("closing stream... done.");
    }

    public double param_estimated (String prod, int param){
	//	String pu = prod.toUpperCase();
	String pu = prod;

	try{
      	if (param == 0)
	    return ((Double)L0_.get(pu)).doubleValue();
	if (param == 1)
	    return ((Double)T_.get(pu)).doubleValue();
	if (param == 2)
	    return ((Double)G_.get(pu)).doubleValue();
	return ((Double)S_.get(pu)).doubleValue();
	}
	catch (Exception e){ // algebra average values
	    if (param == 0) 
		return 0.42;
	    else if (param == 1)
		return 0.14;
	    else if (param == 2)
		return 0.26;
	    else return 0.08;
	}
	
    }


    public void readinpknows(){
	StreamTokenizer pf_ = null;
	try{
	    pf_ = new StreamTokenizer(new FileReader(pknowfile));
	}
	catch (FileNotFoundException fnfe){
	    fnfe.printStackTrace();
	}
	
	try{
	boolean quitnow = false;
	while (!quitnow){
	    int tt = pf_.nextToken();
	    if (tt == StreamTokenizer.TT_EOF)
		quitnow = true;
	    else{
		while (tt != StreamTokenizer.TT_WORD)
		    tt = pf_.nextToken();
		String skill = pf_.sval;
		tt = pf_.nextToken();
		double L0 = pf_.nval;
		tt = pf_.nextToken();
		double T = pf_.nval;
		tt = pf_.nextToken();
		double G = pf_.nval;
		tt = pf_.nextToken();
		double S = pf_.nval;

		L0_.put(skill, new Double(L0));
		T_.put(skill, new Double(T));
		G_.put(skill, new Double(G));
		S_.put(skill, new Double(S));
	    }
	}
	}
	catch (Exception e){e.printStackTrace();}

    }

    public static void main (String args[]){

	ktcode2 ktc_ = new ktcode2();
	DataShopToGamingDetectorpt2A mdd = new DataShopToGamingDetectorpt2A();

	mdd.readinpknows();
	mdd.learn_sdev_mean();
	//mdd.print_out_hashtables();

	mdd.retrack_all=true;

	mdd.distill();			   
    }
}
