// run data through first DataShopSTPreprocessor and then DataShopBlankRemoverPreprocessor (or RonDimensionalityReducer, which duplicates BlankRemover) before converting format with this program

// in second distillation round, combines all NEXTZHINT into most recent INITIALZHINT

import java.io.*;

public class DataShopToGamingDetectorpt1E {

    public static String algebra_hampton_in = "C:\\RawData\\HamptonAlgI0506\\export-modE.txt";
    public static String algebra_hampton_out = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C.txt";
    public static String algebra_hampton_out_tr = "C:\\Study-Analyses\\TextReplays\\AlgebraGeometry\\HamptonAlgI0506C-TR.txt";
    public static String algebra_hampton_out_bntsm = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C-BNTSM.txt";
    public static String algebra_hampton_out_pln = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C-PLN-A.txt";
    public static String algebra_hampton_out_mla = "C:\\RawData\\HamptonAlgI0506\\HamptonAlgI0506C-MLA-A.txt";

    public static String geometry_hampton_in = "C:\\RawData\\HamptonGeoFall2005\\export-modB.txt";
    public static String geometry_hampton_out = "C:\\RawData\\HamptonGeoFall2005\\HamptonGeo0506B.txt";
    public static String geometry_hampton_out_tr = "C:\\Study-Analyses\\TextReplays\\AlgebraGeometry\\HamptonGeo0506B-TR.txt";
    public static String geometry_hampton_out_bntsm = "C:\\RawData\\HamptonGeoFall2005\\HamptonGeo0506B-BNTSM.txt";
    public static String geometry_hampton_out_mla = "C:\\RawData\\HamptonGeoFall2005\\HamptonGeo0506B-MLA-B.txt";
  
    // public static String ronex_in = "C:\\RawData\\RonExampleTutors\\exampletutor-modB.txt";
    public static String ronex_in = "C:\\RawData\\RonExampleTutors\\RonExampleTutorsA-KCunified-B.txt";
    public static String ronex_out_tr = "C:\\RawData\\RonExampleTutors\\RonExampleTutorsA-TR.txt";
    public static String ronex_out_bntsm = "C:\\RawData\\RonExampleTutors\\RonExampleTutorsA-BNTSM.txt";
    public static String ronex_out_mla = "C:\\RawData\\RonExampleTutors\\RonExampleTutorsA-MLA.txt";

    public static String circles_in = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles-modC.txt";
    public static String circles_out_bntsm = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles-BNTSM.txt";

   public static String algebra_cwctc2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005-modB.txt";
    public static String algebra_cwctc2005_out_mla = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005-MLA.txt";

    public static String algebra_wilk2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005-modB.txt";
    public static String algebra_wilk2005_out_mla = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005-MLA.txt";

    public static String RAND2007_in = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export-modB.txt";
    public static String RAND2007_out_mla = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export-MLA.txt";

    public static String geo_wilk2005_in = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export-modB.txt";
    public static String geo_wilk2005_out_mla = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export-MLA.txt";
    public static String geo_cwctc2005_out_mla = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export-MLA.txt";
    public static String geo_cwctc2005_in = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export-modB.txt";


    public String in_file_ = "";
    public String out_file_ = "";
    public FileReader in_;
    public FileWriter out_;
    int curchar = -77; 
    int lineno = 1;
    public boolean for_gaming_detector = false;
    public boolean for_text_replay = false;
    public boolean print_orig_ln = true;
    public boolean bntsm = false;
    public String lesson_type = "RAND"; // or "GEOMETRY" or "RONEX" or "ALGEBRA", "ALGEBRA-NS", "RAND", "GEOMETRY-2005"
    public boolean excel_processed = false;

    public FileReader create_tokenizer(String infile){		      
	
	try{
	    return new FileReader(infile);
	}	
	catch (FileNotFoundException fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }	
    public FileWriter out_tokenizer(String outfile){
	try{
	    return new FileWriter(outfile);
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }

    public void skipToEOL() throws IOException{
	while ((curchar != 10)&&(curchar != -1))
	    curchar = in_.read();
    }

    public String read_in_field() throws IOException{	
	char[] forconvert = new char[1];
	
	String toret = ""; 
	curchar = in_.read(); 
	while ((curchar != 9)&&(curchar != -1)&&(curchar != 10)){
	    if ((curchar != 9)&&(curchar != -1)&&(curchar != 10)){
		forconvert[0] = (char)curchar;
		toret = toret + new String(forconvert);
		curchar = in_.read(); 
	    }
	    if (curchar == 10)
		throw new RuntimeException("Unexpected EOLN encountered");
	    //System.out.println(curchar);
	}
	//System.out.println();
	return toret;
    }

    public String startsCapName(String namein){
	String nameout = ""; int incount = 12; int outcount = 0;
	char c[] = new char[1];
	if (namein.charAt(0)!='[')
	    incount=0;
	while (outcount < 15){
	    try{
		c[0] = namein.charAt(incount);
		if ((outcount == 0)&&(java.lang.Character.isDigit(c[0]))){
		    nameout = nameout + "N";
		    outcount++;
		}
		if ((java.lang.Character.isDigit(c[0]))||(java.lang.Character.isUpperCase(c[0]))||(java.lang.Character.isLowerCase(c[0]))){
		    nameout = nameout + new String(c);
		    outcount++;
		}		
	    }
	    catch (IndexOutOfBoundsException e){ outcount=15;}
	    incount++;
	}
	return nameout;
    }    

    public String simplify_prodname(String prodin){
	//System.out.println(lineno);
	if (for_text_replay)
	    return prodin;
	String prodout = ""; int incount = 12; int outcount = 0;
	char c[] = new char[1];
	if (prodin.charAt(0)!='[')
	    incount=0;
	while (outcount < 40){
	    try{
		c[0] = prodin.charAt(incount);
		if ((java.lang.Character.isUpperCase(c[0]))||(java.lang.Character.isLowerCase(c[0]))||(java.lang.Character.isDigit(c[0]))){
		    prodout = prodout + new String(c);
		    outcount++;
		}		
	    }
	    catch (IndexOutOfBoundsException e){ outcount=40;}
	    incount++;
	}
	return prodout;
    }    

    public String simplify_input(String stepin){	
	if (for_text_replay)
	    return stepin;
	String stepout = ""; int incount = 0; int outcount = 0;
	char c[] = new char[1];	
	while (outcount < 15){
	    try{
		c[0] = stepin.charAt(incount);
		if ((java.lang.Character.isDigit(c[0]))||(java.lang.Character.isUpperCase(c[0]))||(java.lang.Character.isLowerCase(c[0]))){
		    stepout = stepout + new String(c);
		    outcount++;
		}		
	    }
	    catch (IndexOutOfBoundsException e){ outcount=15;}
	    incount++;
	}
	return stepout;
    }

    public String simplify_stepname(String stepin){	
	if (for_text_replay)
	    return stepin;
	String stepout = ""; int incount = 0; int outcount = 0;
	char c[] = new char[1];	
	while (outcount < 40){
	    try{
		c[0] = stepin.charAt(incount);
		if ((outcount == 0)&&(java.lang.Character.isDigit(c[0]))){
		    stepout = stepout + "N";
		    outcount++;
		}
		if ((java.lang.Character.isDigit(c[0]))||(java.lang.Character.isUpperCase(c[0]))||(java.lang.Character.isLowerCase(c[0]))){
		    stepout = stepout + new String(c);
		    outcount++;
		}		
	    }
	    catch (IndexOutOfBoundsException e){ outcount=40;}
	    incount++;
	}
	return stepout;
    }

    public double convert_time(String timestring){
	try{
	double toret=0;
	//System.out.println(timestring);
	int base = 11; 
	//if (excel_processed) 
	//    base = 0;

	toret = toret + (new Double(timestring.substring(base+6,base+10))).doubleValue();
	toret = toret + ((new Double(timestring.substring(base+3,base+5))).doubleValue() * 60.0);	
	toret = toret + ((new Double(timestring.substring(base,base+2))).doubleValue() * 3600.0);
	//System.out.println(toret);
	
	return toret;
	}catch(Exception e){
	       System.out.println(lineno);System.out.println("CT");
	}
	return 0;
    }

    public void convertFormat_part1(){
	in_ = create_tokenizer(in_file_);
	out_ = out_tokenizer(out_file_);

	java.util.Hashtable skills_seen_thisprob = new java.util.Hashtable();

	String curname = ""; String session = ""; String day = "";
	String time = ""; String timezone_cx = ""; String actiontype = "";
	String actionsubtype_cx = ""; String tutoractiontype = "";
	String tutoractionsubtype_cx = ""; String curlesson = "";
	String section_cx = ""; String problem = ""; String step = "";
	String attemptatstep = ""; String outcome = "";
	String selection = ""; String action = "";
	String input = ""; String feedbacktext = ""; String feedbacktype = "";
	String helplevel = ""; String totalnumhints = ""; String conditionname = "";
	String conditiontype = ""; String prod1 = "BLANK"; String prodcx1 = "";
	String prod2 = ""; String prodcx2 = ""; String prod3 = ""; String prodcx3 = "";
	String school = ""; String clazz = ""; String leveldefault = "";

	String prevprod = "BLANK"; double prevtime = 0; double time_n = 0; double elapsed = 0;
	String prevname = ""; String prevsession = ""; boolean firstline = true;
	double intermedtime = 0; int numsteps = -1; lineno = 2;
	String newproblem = "1.0";

	String prevproblem = "BLANK"; String firsttimethisprob = "0";
	boolean readyforaline = true;

	try{
	    if (bntsm)
		out_.write("num\tuser\tskill\tknowledge\tasr_accept\n");

	    skipToEOL();
	    curchar = in_.read();
	    skipToEOL();
	    
	    while (curchar != -1){ // EOF
		lineno++;
		prevprod = prod1;
		prevtime = time_n;
		prevname = curname;
		prevsession = session;
		
		//read in DataShop line
		curname = read_in_field();
		session = read_in_field();
		//day = read_in_field();
		if (!lesson_type.equals("CIRCLES")){
		    time = read_in_field();
		    time_n = convert_time(time);
		}
		timezone_cx = read_in_field();
		actiontype = read_in_field();
		actionsubtype_cx = read_in_field();
		tutoractiontype= read_in_field();
		tutoractionsubtype_cx= read_in_field();

		if (lesson_type.equals("ALGEBRA-NS")){
		    read_in_field(); // not sure why it's there
		}

		curlesson= read_in_field();
		section_cx= read_in_field();

		prevproblem = problem;
		problem= read_in_field();		

		step= read_in_field();
		attemptatstep= read_in_field();
		outcome= read_in_field();
		selection= read_in_field();
		action= read_in_field();
	        input= read_in_field();
		feedbacktext= read_in_field();
		feedbacktype= read_in_field();
		if (!lesson_type.equals("ALGEBRA-NS"))
		    helplevel= read_in_field();
		totalnumhints= read_in_field();

		//	if (lesson_type.equals("RAND"))
		//  read_in_field(); // totally blank, not sure what it ought to be

		if (lesson_type.equals("ALGEBRA")||lesson_type.equals("RONEX")||lesson_type.equals("CIRCLES")||lesson_type.equals("RAND")){
		    conditionname= read_in_field();
		    conditiontype= read_in_field();
		}
		/**	if (lesson_type.equals("CIRCLES")){
		    read_in_field(); read_in_field(); 
		    }*/	     

		if (!lesson_type.equals("RAND")){
		    prod2= read_in_field();
		    prodcx2= read_in_field();
		    prod1= read_in_field(); 
		    prodcx1= read_in_field();
		    prod3= read_in_field();
		    prodcx3= read_in_field();
		}else{
		    prod1= read_in_field(); 
		    prodcx1= read_in_field();
		    prod3= read_in_field();
		    prodcx3= read_in_field();
		    prod2= read_in_field();
		    prodcx2= read_in_field();
		    read_in_field(); read_in_field();
		}		
		
		if (!lesson_type.equals("RONEX")){
		    school= read_in_field();
		    clazz= read_in_field();
		}
		if (lesson_type.equals("GEOMETRY")) 
		    read_in_field(); // pknow tracking, but rarely so
	      
		// a little bit of pre-processing

		newproblem="0.0";

		if (!prevproblem.equals(problem)){
		    newproblem = "1.0";
		    skills_seen_thisprob = new java.util.Hashtable();
		}

		if (!prod1.equals("BLANK")){
		    if (skills_seen_thisprob.get(prod1) == null)
			firsttimethisprob = "1";
		    else
			firsttimethisprob = "0";
		    skills_seen_thisprob.put(prod1,prod1); 
		}else
		    firsttimethisprob = "."; // not really relevant if this is the first time this production has been seen this problem... if no production is tracked

		// write out gaming detector line
		if (outcome.equals("NEXTZHINT")){
		    elapsed = time_n - prevtime;
		    intermedtime += elapsed;
		    numsteps ++;
		}else{
	        if (firstline)
		    firstline = false;
		else{
		    
		    if (!bntsm){
			out_.write((new Double(intermedtime)).toString());
			out_.write("\t");
			out_.write((new Integer(numsteps)).toString());
			out_.write("\t");
		    }
		    if (readyforaline){
			out_.write("\n");
			out_.flush();
			readyforaline = false;
		    }
		    
		}

		if ((!bntsm)||(firsttimethisprob.equals("1"))){

		readyforaline = true;
		intermedtime = -1;
		numsteps = -1;

		if (print_orig_ln){
		    out_.write((new Integer(lineno)).toString());
		    out_.write("\t");
		}

		if (!bntsm){
		    out_.write(curlesson);
		    out_.write("\t");
		}
		out_.write(startsCapName(curname));
		out_.write("\t");

		if (!bntsm){
		    //System.out.println(outcome);
		    if ((outcome.equals("OK"))||(outcome.equals("CORRECT")))
			out_.write("RIGHT\t");else
			if (outcome.equals("BUG"))
			    out_.write("BUG\t");else
			    if (outcome.endsWith("HINT")){
				out_.write("HELP\t");
				intermedtime = 0;
				numsteps = 0;
			    }else
				if ((outcome.equals("ERROR"))||(outcome.equals("INCORRECT")))
				    out_.write("WRONG\t");else{
				    out_.write(outcome);
				    out_.write("\t");
				}
		}

		if (!bntsm){
		    out_.write(simplify_stepname(step));
		    out_.write("\t");
		    out_.write("UNKNOWN\t"); // widget type
		}


		if (for_text_replay){
		    out_.write(action);
		    out_.write("\t");
		}		

		if ((!bntsm)&&(!for_gaming_detector)){
		    out_.write(simplify_input(input));
		    out_.write("\t");
		}

		if (for_text_replay){
		    out_.write(feedbacktext);
		    out_.write("\t");
		    out_.write(feedbacktype);
		    out_.write("\t");
		}

	       	out_.write(simplify_prodname(prod1)); // only counts first production for compatibility (at loss of some precision)
	       	out_.write("\t");

		if (!bntsm)
		    out_.write("-1\t"); // pknow not included
	
		if ((!bntsm)&&(!for_text_replay)&&(!for_gaming_detector)){
		    out_.write(firsttimethisprob);
		    out_.write("\t");
		}
		
		if (!bntsm){
		    elapsed = time_n - prevtime;
		    //System.out.print(elapsed);
		    //System.out.print("\t");
		    if ((prevtime == 0)||(!prevsession.equals(session))||(!prevname.equals(curname)))
			elapsed = -1; // need to make sure gaming detector accounts properly for this!
		    //System.out.println(elapsed);
		    out_.write(new String((new Double(elapsed)).toString()));
		    out_.write("\t");
		}

		if (for_gaming_detector){
		    out_.write(newproblem);
		    out_.write("\t");
		}

		if (bntsm){
		    //System.out.println(outcome);
		    out_.write("NULL\t");
		    if ((outcome.equals("OK"))||(outcome.equals("CORRECT")))
			out_.write("2");
		    else
			out_.write("1");
		    out_.write("\t");
		}	 
		}
		}
		    

		skipToEOL(); 
		//tt = in_.nextToken();
	    }
	    if (!bntsm){
		out_.write((new Double(intermedtime)).toString());
		out_.write("\t");
		out_.write((new Integer(numsteps)).toString());
		out_.write("\t");
	    }
	    out_.write("\n");
	    out_.flush();
	    out_.close();
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
    }

    public static void main (String args[]){	
	DataShopToGamingDetectorpt1E d_ = new DataShopToGamingDetectorpt1E();

	if (args[0].equals("ahp1")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.lesson_type = "ALGEBRA";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("ahp1-tr")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out_tr;
	    d_.for_text_replay = true;
	    d_.bntsm = false;
	    d_.lesson_type = "ALGEBRA";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ahp1-pln")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out_pln;
	    d_.for_text_replay = true;
	    d_.bntsm = false;
	    d_.print_orig_ln=true;
	    d_.lesson_type = "ALGEBRA";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ahp1-bntsm")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out_bntsm;
	    d_.for_text_replay = false;
	    d_.bntsm = true;
	    d_.lesson_type = "ALGEBRA";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ahp1-mla")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "ALGEBRA";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ghp1")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.lesson_type = "GEOMETRY";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("ghp1-tr")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out_tr;
	    d_.for_text_replay = true;
	    d_.bntsm = false;
	    d_.lesson_type = "GEOMETRY";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ghp1-bntsm")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out_bntsm;
	    d_.for_text_replay = false;
	    d_.bntsm = true;
	    d_.lesson_type = "GEOMETRY";
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ghp1-mla")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "GEOMETRY";
	    d_.convertFormat_part1();
	}else
	if (args[0].equals("ronex-tr")){
	    d_.in_file_ = ronex_in;
	    d_.out_file_ = ronex_out_tr;
	    d_.for_text_replay = true;
	    d_.bntsm = false;
	    d_.lesson_type = "RONEX";
	    d_.excel_processed = true;
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ronex-bntsm")){
	    d_.in_file_ = ronex_in;
	    d_.out_file_ = ronex_out_bntsm;
	    d_.for_text_replay = false;
	    d_.bntsm = true;
	    d_.lesson_type = "RONEX";
	    d_.excel_processed = true;
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("ronex-mla")){
	    d_.in_file_ = ronex_in;
	    d_.out_file_ = ronex_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "RONEX";
	    d_.excel_processed = true;
	    d_.convertFormat_part1();
        }else
	if (args[0].equals("gc2005")){
	    d_.in_file_ = geo_cwctc2005_in;
	    d_.out_file_ = geo_cwctc2005_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "GEOMETRY-2005";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("gw2005")){
	    d_.in_file_ = geo_wilk2005_in;
	    d_.out_file_ = geo_wilk2005_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "GEOMETRY-2005";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("aw2005")){
	    d_.in_file_ = algebra_wilk2005_in;
	    d_.out_file_ = algebra_wilk2005_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.lesson_type = "ALGEBRA-NS";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("RAND")){
	    d_.in_file_ = RAND2007_in;
	    d_.out_file_ = RAND2007_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.print_orig_ln=false;
	    d_.lesson_type = "RAND";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("ac2005")){
	    d_.in_file_ = algebra_cwctc2005_in;
	    d_.out_file_ = algebra_cwctc2005_out_mla;
	    d_.for_text_replay = false;
	    d_.bntsm = false;
	    d_.for_gaming_detector = true;
	    d_.print_orig_ln=false;
	    d_.lesson_type = "ALGEBRA-NS";
	    d_.convertFormat_part1();
        }	else
	if (args[0].equals("circles-bntsm")){
	    d_.in_file_ = circles_in;
	    d_.out_file_ = circles_out_bntsm;
	    d_.for_text_replay = false;
	    d_.bntsm = true;
	    d_.for_gaming_detector = false;
	    d_.print_orig_ln=false;
	    d_.lesson_type = "CIRCLES";
	    d_.excel_processed = true;
	    d_.convertFormat_part1();
        }
	else System.out.println("No conversion specified");

    }
}