public class ktcode2 {

    public java.util.Hashtable skills_ = new java.util.Hashtable();
    public static final double _MASTERY_ = 0.95;


    public void setSkill (String skill, double L){
	Double estimates [] = new Double[4];
	estimates[0] = new Double(L); // L
	estimates[1] = new Double(0.1); // T
	estimates[2] = new Double(0.3); // G
	estimates[3] = new Double(0.4); // S
	skills_.put(skill, estimates);
    }

    public void initializeSkill (String skill){
	Double estimates [] = new Double[4];
	estimates[0] = new Double(0.1); // L
	estimates[1] = new Double(0.1); // T
	estimates[2] = new Double(0.3); // G
	estimates[3] = new Double(0.4); // S
	skills_.put(skill, estimates);
    }

    public void initializeSkill (String skill, double L, double T, double G, double S){
	Double estimates [] = new Double[4];
	estimates[0] = new Double(L); // L
	estimates[1] = new Double(T); // T
	estimates[2] = new Double(S); // G
	estimates[3] = new Double(G); // S
	skills_.put(skill, estimates);
    }

    public double getCurrentSkill (String skill){
	Double estimates [] = (Double[]) (skills_.get(skill));
	if (estimates == null)
	    return -1.0;
 	else
	    return estimates[0].doubleValue();
    }

    public boolean atMastery (String skill){
	return (getCurrentSkill(skill)>_MASTERY_);
    }

    public void updateSkill(String skill, boolean success){
	Double estimates [] = (Double[]) (skills_.get(skill));
	if (estimates == null)
	    System.out.println("nonexistent skill!");
	double cur_L = estimates[0].doubleValue();
	double cur_T = estimates[1].doubleValue();
	double cur_G = estimates[2].doubleValue();
	double cur_S = estimates[3].doubleValue();
	double cur_prevL = estimates[0].doubleValue();

	if (success){
	    cur_prevL=((cur_prevL*(1-cur_S))/((cur_prevL*(1-cur_S))+((1-cur_prevL)*cur_G)));
	    cur_L = cur_prevL + (cur_T * (1-cur_prevL));
	}
	else{
	    cur_prevL=((cur_prevL*cur_S)/((cur_prevL*cur_S)+((1-cur_prevL)*(1-cur_G))));
	    cur_L = cur_prevL + (cur_T * (1-cur_prevL));
	} 
	estimates[0] = new Double(cur_L);

	skills_.remove(skill);
	skills_.put(skill, estimates);
	
    }

    public static void main (String args[]){
	ktcode2 c_ = new ktcode2();
        c_.initializeSkill("Murgling");
	System.out.println(c_.getCurrentSkill("Murgling"));
	c_.updateSkill("Murgling", true);
	c_.updateSkill("Murgling", true);
	c_.updateSkill("Murgling", true);
	System.out.println(c_.getCurrentSkill("Murgling"));
	c_.updateSkill("Murgling", false);
	System.out.println(c_.getCurrentSkill("Murgling"));
	System.out.println(c_.atMastery("Murgling"));
    }
}
